// tempus 2000.11

//
// tempus, version 2000.11, (c) Copyright 1995-2000, MZA Associates Corporation
// Generated on: Wed Jul 18 07:48:21 MDT 2001
//

#include "tempus.h"
#include "Recorders.h"
#include "FileSys.h"

#include "TutA.h"

#ifndef NO_TEMPUS_SMF_MONITOR
#include "TempusStatusSMF.h"
#endif

main(int argc, char* argv[])
{
   double stopTime = 0.002;
   int ___ierr;
   char *___outfile="TutARunsetA.trf";
   float  target_range = 50000;
   float  tel_focus_range = target_range;
   float  tel_diam = 0.75;
   float  hel_wavelength = 1.0e-6;
   int  tbd_nxy = 100;
   float  tbd_dxy = 0.01;
   ParamSet pssetA;
   writeParam(pssetA, "stopTime", DOUBLE, &stopTime);
   char *___trfname;
   char *___filename;
   int ___totalRuns, ___currentRun;
   int ___newDataFile = 0;
   ___totalRuns = 1;
   ___currentRun = 1;

#ifndef NO_TEMPUS_SMF_MONITOR
   char *___smfname;
   parseName(argc, argv, ___outfile, &___smfname, &___trfname, stopTime);
   TempusStatusSMFWriter ___smfWriter(___smfname, ___trfname, "",___totalRuns);
   setCurrentSMF(&___smfWriter);
#else
   char *___tmpbuf;
   parseName(argc, argv, ___outfile, &___tmpbuf, stopTime);
   ___trfname = checkName(___tmpbuf);
   delete [] ___tmpbuf;
#endif

   Universe usetA("usetA");
   Trace ___trace("runset rsetA:");  ___trace.newline();

#ifndef NO_TEMPUS_SMF_MONITOR
   ___smfWriter.startNewRun(___currentRun, stopTime);
#endif

   TutA setA(NULL, "setA",
              target_range,
              tel_focus_range,
              tel_diam,
              hel_wavelength,
              tbd_nxy,
              tbd_dxy);

   // External Inputs
   // Connect external inputs
   writeParam(pssetA, "target_range", FLOAT, &target_range);
   writeParam(pssetA, "tel_focus_range", FLOAT, &tel_focus_range);
   writeParam(pssetA, "tel_diam", FLOAT, &tel_diam);
   writeParam(pssetA, "hel_wavelength", FLOAT, &hel_wavelength);
   writeParam(pssetA, "tbd_nxy", INT, &tbd_nxy);
   writeParam(pssetA, "tbd_dxy", FLOAT, &tbd_dxy);

   RecorderFile rfsetA(NULL, "rfsetA", ___trfname, ParamSet_stringify(pssetA), pssetA);
   GridRecorder<float> rfsetA1(NULL, "rfsetA1", "setA.targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", true, (float)0.0, 0.0);
   rfsetA1.dr <<= rfsetA.dr;
   rfsetA1.i <<= setA.targetboard.integrated_intensity;


#ifndef NO_TEMPUS_SMF_MONITOR
   advanceTime(stopTime, ___smfWriter);
   ___smfWriter.Pausing();
#else
   advanceTime(stopTime);
#endif

   ___currentRun++;

#ifndef NO_TEMPUS_SMF_MONITOR
   TempusStatusSMFDynamic* ___smfDynamic = ___smfWriter.getDynamicPtr();
   ___smfDynamic->iRun = ___totalRuns + 1;
#endif

   return(0);
}
