// tempus 2000.11

//
// tempus, version 2000.11, (c) Copyright 1995-2000, MZA Associates Corporation
// Generated on: Wed Jul 18 10:21:19 MDT 2001
//

#include "tempus.h"
#include "Recorders.h"
#include "FileSys.h"

#include "TutB.h"

#ifndef NO_TEMPUS_SMF_MONITOR
#include "TempusStatusSMF.h"
#endif

main(int argc, char* argv[])
{
   double stopTime = 0.002;
   int ___ierr;
   char *___outfile="TutBRunsetA.trf";
   int  nscreen = 5;
   float  alpha = 1.0;
   float  hPlatform = 2400;
   float  hTarget = 2400;
   float  target_range = 50000;
   float  tel_focus_range = target_range;
   float  tel_diam = 0.75;
   float  hel_wavelength = 1.0e-6;
   float  ptsc_wavelength = hel_wavelength;
   float  ptsc_x = 0.0;
   float  ptsc_y = 0.0;
   AcsAtmSpec  AtmSpec = AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range);
   char   ___AtmSpecStr[159];
   sprintf(___AtmSpecStr,"(AcsAtmSpec)  AcsAtmSpec(ptsc_wavelength,nscreen,alpha,hPlatform,hTarget,target_range)\n\0");
   float  x_wind = 10.0;
   float  y_wind = 0.0;
   int  propnxy = 256;
   float  propdxy = 0.02;
   int  tbd_nxy = 100;
   float  tbd_dxy = 0.01;
   int  img_nxy = 100;
   float  img_dxy = tbd_dxy/target_range;
   ParamSet pssetA;
   int rand_index = 0;
   writeParam(pssetA, "rand_index", LOOP, &rand_index);
   writeParam(pssetA, "stopTime", DOUBLE, &stopTime);
   char *___trfname;
   char *___filename;
   int ___totalRuns, ___currentRun;
   int ___newDataFile = 0;
   ___totalRuns = 2;
   ___currentRun = 1;

#ifndef NO_TEMPUS_SMF_MONITOR
   char *___smfname;
   parseName(argc, argv, ___outfile, &___smfname, &___trfname, stopTime);
   TempusStatusSMFWriter ___smfWriter(___smfname, ___trfname, "",___totalRuns);
   setCurrentSMF(&___smfWriter);
#else
   char *___tmpbuf;
   parseName(argc, argv, ___outfile, &___tmpbuf, stopTime);
   ___trfname = checkName(___tmpbuf);
   delete [] ___tmpbuf;
#endif

   Universe usetA("usetA");
   Trace ___trace("runset rsetA:");  ___trace.newline();
   for (rand_index=0; rand_index < 2; rand_index++)
   {
      Universe usetA("usetA");

#ifndef NO_TEMPUS_SMF_MONITOR
      ___smfWriter.Pausing();
#endif

      Trace ___trace("loop rand_index = ");  ___trace.out() << rand_index; ___trace.newline();
      int  AtmSeed = seedSequence(-123456789,rand_index);
      checkLimit(&___newDataFile,  ___trfname, ___outfile, &___currentRun, &___totalRuns);
      if(___newDataFile < 0) {
         delete [] ___filename;
         ___filename = checkName(___trfname);
         ___newDataFile = 0;
         TK_start_timing = TK_timer.cpuTime();
      }

#ifndef NO_TEMPUS_SMF_MONITOR
      ___smfWriter.startNewRun(___currentRun, stopTime);
#endif

      TutB setA(NULL, "setA",
                 tel_focus_range,
                 tel_diam,
                 hel_wavelength,
                 ptsc_wavelength,
                 ptsc_x,
                 ptsc_y,
                 AtmSpec,
                 AtmSeed,
                 x_wind,
                 y_wind,
                 propnxy,
                 propdxy,
                 tbd_nxy,
                 tbd_dxy,
                 img_nxy,
                 img_dxy);

      // External Inputs
      // Connect external inputs
      writeParam(pssetA, "rand_index", LOOP, &rand_index);
      writeParam(pssetA, "nscreen", INT, &nscreen);
      writeParam(pssetA, "alpha", FLOAT, &alpha);
      writeParam(pssetA, "hPlatform", FLOAT, &hPlatform);
      writeParam(pssetA, "hTarget", FLOAT, &hTarget);
      writeParam(pssetA, "target_range", FLOAT, &target_range);
      writeParam(pssetA, "tel_focus_range", FLOAT, &tel_focus_range);
      writeParam(pssetA, "tel_diam", FLOAT, &tel_diam);
      writeParam(pssetA, "hel_wavelength", FLOAT, &hel_wavelength);
      writeParam(pssetA, "ptsc_wavelength", FLOAT, &ptsc_wavelength);
      writeParam(pssetA, "ptsc_x", FLOAT, &ptsc_x);
      writeParam(pssetA, "ptsc_y", FLOAT, &ptsc_y);
      writeParam(pssetA, "AtmSpec", OTHER_TYPE, ___AtmSpecStr);
      writeParam(pssetA, "AtmSeed", INT, &AtmSeed);
      writeParam(pssetA, "x_wind", FLOAT, &x_wind);
      writeParam(pssetA, "y_wind", FLOAT, &y_wind);
      writeParam(pssetA, "propnxy", INT, &propnxy);
      writeParam(pssetA, "propdxy", FLOAT, &propdxy);
      writeParam(pssetA, "tbd_nxy", INT, &tbd_nxy);
      writeParam(pssetA, "tbd_dxy", FLOAT, &tbd_dxy);
      writeParam(pssetA, "img_nxy", INT, &img_nxy);
      writeParam(pssetA, "img_dxy", FLOAT, &img_dxy);

      RecorderFile rfsetA(NULL, "rfsetA", ___trfname, ParamSet_stringify(pssetA), pssetA);
      GridRecorder<float> rfsetA1(NULL, "rfsetA1", "setA.targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", true, (float)0.0, 0.0);
      rfsetA1.dr <<= rfsetA.dr;
      rfsetA1.i <<= setA.targetboard.integrated_intensity;
      GridRecorder<float> rfsetA2(NULL, "rfsetA2", "setA.camera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", true, (float)0.0, 0.0);
      rfsetA2.dr <<= rfsetA.dr;
      rfsetA2.i <<= setA.camera.fpaImage;


#ifndef NO_TEMPUS_SMF_MONITOR
      advanceTime(stopTime, ___smfWriter);
      ___smfWriter.Pausing();
#else
      advanceTime(stopTime);
#endif

   ___currentRun++;
   }

#ifndef NO_TEMPUS_SMF_MONITOR
   TempusStatusSMFDynamic* ___smfDynamic = ___smfWriter.getDynamicPtr();
   ___smfDynamic->iRun = ___totalRuns + 1;
#endif

   return(0);
}
