// tempus 2000.11

//
// tempus, version 2000.11, (c) Copyright 1995-2000, MZA Associates Corporation
// Generated on: Wed Jul 18 11:35:58 MDT 2001
//

#include "tempus.h"
#include "Recorders.h"
#include "FileSys.h"

#include "TutB.h"

#ifndef NO_TEMPUS_SMF_MONITOR
#include "TempusStatusSMF.h"
#endif

main(int argc, char* argv[])
{
   double stopTime = 0.002;
   int ___ierr;
   char *___outfile="TutBRunsetB.trf";
   int  nscreen = 5;
   float  alpha[2] = {1.0,2.0};
   Array<float>  alpha_array(2);
   for(int mli_alpha_0 = 0; mli_alpha_0 < 2; mli_alpha_0++)
      alpha_array(mli_alpha_0) = alpha[mli_alpha_0];

   float  hPlatform = 2400;
   float  hTarget = 2400;
   float  target_range = 50000;
   float  tel_focus_range = target_range;
   float  tel_diam = 0.75;
   float  hel_wavelength = 1.0e-6;
   float  ptsc_wavelength = hel_wavelength;
   float  ptsc_x = 0.0;
   float  ptsc_y = 0.0;
   float  x_wind = 10.0;
   float  y_wind = 0.0;
   int  propnxy = 256;
   float  propdxy = 0.02;
   int  tbd_nxy = 100;
   float  tbd_dxy = 0.01;
   int  img_nxy = 100;
   float  img_dxy = tbd_dxy/target_range;
   ParamSet pssetB;
   int rand_index = 0;
   writeParam(pssetB, "rand_index", LOOP, &rand_index);
   int alpha_index = 0;
   writeParam(pssetB, "alpha_index", LOOP, &alpha_index);
   writeParam(pssetB, "stopTime", DOUBLE, &stopTime);
   char *___trfname;
   char *___filename;
   int ___totalRuns, ___currentRun;
   int ___newDataFile = 0;
   ___totalRuns = 2;
   ___currentRun = 1;

#ifndef NO_TEMPUS_SMF_MONITOR
   char *___smfname;
   parseName(argc, argv, ___outfile, &___smfname, &___trfname, stopTime);
   TempusStatusSMFWriter ___smfWriter(___smfname, ___trfname, "",___totalRuns);
   setCurrentSMF(&___smfWriter);
#else
   char *___tmpbuf;
   parseName(argc, argv, ___outfile, &___tmpbuf, stopTime);
   ___trfname = checkName(___tmpbuf);
   delete [] ___tmpbuf;
#endif

   Universe usetB("usetB");
   Trace ___trace("runset rsetB:");  ___trace.newline();
   for (rand_index=0; rand_index < 1; rand_index++)
   {
      Trace ___trace("loop rand_index = ");  ___trace.out() << rand_index; ___trace.newline();
      int  AtmSeed = seedSequence(-123456789,rand_index);
      for (alpha_index=0; alpha_index < 2; alpha_index++)
      {
         Universe usetB("usetB");

#ifndef NO_TEMPUS_SMF_MONITOR
         ___smfWriter.Pausing();
#endif

         Trace ___trace("loop alpha_index = ");  ___trace.out() << alpha_index; ___trace.newline();
         AcsAtmSpec  AtmSpec = AcsAtmSpec(ptsc_wavelength,nscreen,alpha[alpha_index],hPlatform,hTarget,target_range);
         char   ___AtmSpecStr[185];
         ___ierr = sprintf(___AtmSpecStr, "(AcsAtmSpec) AcsAtmSpec(ptsc_wavelength,nscreen,alpha[alpha_index],hPlatform,hTarget,target_range)\n\0");
         checkLimit(&___newDataFile,  ___trfname, ___outfile, &___currentRun, &___totalRuns);
         if(___newDataFile < 0) {
            delete [] ___filename;
            ___filename = checkName(___trfname);
            ___newDataFile = 0;
            TK_start_timing = TK_timer.cpuTime();
         }

#ifndef NO_TEMPUS_SMF_MONITOR
         ___smfWriter.startNewRun(___currentRun, stopTime);
#endif

         TutB setB(NULL, "setB",
                    tel_focus_range,
                    tel_diam,
                    hel_wavelength,
                    ptsc_wavelength,
                    ptsc_x,
                    ptsc_y,
                    AtmSpec,
                    AtmSeed,
                    x_wind,
                    y_wind,
                    propnxy,
                    propdxy,
                    tbd_nxy,
                    tbd_dxy,
                    img_nxy,
                    img_dxy);

         // External Inputs
         // Connect external inputs
         writeParam(pssetB, "rand_index", LOOP, &rand_index);
         writeParam(pssetB, "alpha_index", LOOP, &alpha_index);
         writeParam(pssetB, "nscreen", INT, &nscreen);
         writeParam(pssetB, "alpha_array", ARRAY_FLOAT, &alpha_array);
         writeParam(pssetB, "hPlatform", FLOAT, &hPlatform);
         writeParam(pssetB, "hTarget", FLOAT, &hTarget);
         writeParam(pssetB, "target_range", FLOAT, &target_range);
         writeParam(pssetB, "tel_focus_range", FLOAT, &tel_focus_range);
         writeParam(pssetB, "tel_diam", FLOAT, &tel_diam);
         writeParam(pssetB, "hel_wavelength", FLOAT, &hel_wavelength);
         writeParam(pssetB, "ptsc_wavelength", FLOAT, &ptsc_wavelength);
         writeParam(pssetB, "ptsc_x", FLOAT, &ptsc_x);
         writeParam(pssetB, "ptsc_y", FLOAT, &ptsc_y);
         writeParam(pssetB, "AtmSpec", OTHER_TYPE, ___AtmSpecStr);
         writeParam(pssetB, "AtmSeed", INT, &AtmSeed);
         writeParam(pssetB, "x_wind", FLOAT, &x_wind);
         writeParam(pssetB, "y_wind", FLOAT, &y_wind);
         writeParam(pssetB, "propnxy", INT, &propnxy);
         writeParam(pssetB, "propdxy", FLOAT, &propdxy);
         writeParam(pssetB, "tbd_nxy", INT, &tbd_nxy);
         writeParam(pssetB, "tbd_dxy", FLOAT, &tbd_dxy);
         writeParam(pssetB, "img_nxy", INT, &img_nxy);
         writeParam(pssetB, "img_dxy", FLOAT, &img_dxy);

         RecorderFile rfsetB(NULL, "rfsetB", ___trfname, ParamSet_stringify(pssetB), pssetB);
         GridRecorder<float> rfsetB1(NULL, "rfsetB1", "setB.targetboard.integrated_intensity", "Grid<float>", "Integrated intensity", true, (float)0.0, 0.0);
         rfsetB1.dr <<= rfsetB.dr;
         rfsetB1.i <<= setB.targetboard.integrated_intensity;
         GridRecorder<float> rfsetB2(NULL, "rfsetB2", "setB.camera.fpaImage", "Grid<float>", "the image formed at focal plane, integrated over each exposure interval", true, (float)0.0, 0.0);
         rfsetB2.dr <<= rfsetB.dr;
         rfsetB2.i <<= setB.camera.fpaImage;


#ifndef NO_TEMPUS_SMF_MONITOR
         advanceTime(stopTime, ___smfWriter);
         ___smfWriter.Pausing();
#else
         advanceTime(stopTime);
#endif

   ___currentRun++;
      }
   }

#ifndef NO_TEMPUS_SMF_MONITOR
   TempusStatusSMFDynamic* ___smfDynamic = ___smfWriter.getDynamicPtr();
   ___smfDynamic->iRun = ___totalRuns + 1;
#endif

   return(0);
}
