// tempus 2000.11
#ifndef WINDATMOPATH_SYSTEM_CLASS
#define WINDATMOPATH_SYSTEM_CLASS
//
// (c) Copyright 1995-2000, MZA Associates Corporation
//

#include "tempus.h"


#include "TransverseVelocity.h"
#include "TransverseVelocity.h"
#include "AtmoPath.h"

class WindAtmoPath : public System
{
public:

   // Parameters
   AcsAtmSpec AtmSpec;
   int AtmSeed;
   int propnxy;
   float propdxy;
   float xwind;
   float ywind;

   // Subsystems
   TransverseVelocity transversevelocity;

   TransverseVelocity transversevelocity2;

   AtmoPath atmosphericpath;


   // Inputs
   Input< WaveTrain > outgoingincident;
   Input< WaveTrain > incomingincident;

   // Outputs
   Output< WaveTrain > outgoingtransmitted;
   Output< WaveTrain > incomingtransmitted;

   WindAtmoPath(SystemNode *parent, char *name,
                AcsAtmSpec _AtmSpec,
                int _AtmSeed,
                int _propnxy,
                float _propdxy,
                float _xwind,
                float _ywind) : 
      System(parent, name),
      AtmSpec(_AtmSpec),
      AtmSeed(_AtmSeed),
      propnxy(_propnxy),
      propdxy(_propdxy),
      xwind(_xwind),
      ywind(_ywind),
      transversevelocity(this, "transversevelocity",
         -xwind,
         -ywind,
         0.0,
         0.0),
      transversevelocity2(this, "transversevelocity2",
         xwind,
         ywind,
         0.0,
         0.0),
      atmosphericpath(this, "atmosphericpath",
         AtmSpec,
         AtmSeed,
         propnxy,
         propdxy,
         1.8,
         0.05,
         -propnxy*propdxy / 2.0,
         propnxy*propdxy / 2.0,
         -propnxy*propdxy / 2.0,
         propnxy*propdxy / 2.0,
         -propnxy*propdxy / 2.0,
         propnxy*propdxy / 2.0,
         -propnxy*propdxy / 2.0,
         propnxy*propdxy / 2.0,
         propdxy),
      outgoingincident(this, "outgoingincident"),
      incomingincident(this, "incomingincident"),
      outgoingtransmitted(this, "outgoingtransmitted"),
      incomingtransmitted(this, "incomingtransmitted")
   {
      outgoingtransmitted <<= transversevelocity2.outgoingTransmitted;
      transversevelocity2.incomingIncident <<= incomingincident;
      transversevelocity.outgoingIncident <<= outgoingincident;
      incomingtransmitted <<= transversevelocity.incomingTransmitted;
      transversevelocity2.outgoingIncident <<= atmosphericpath.outgoingTransmitted;
      transversevelocity.incomingIncident <<= atmosphericpath.incomingTransmitted;
      atmosphericpath.outgoingIncident <<= transversevelocity.outgoingTransmitted;
      atmosphericpath.incomingIncident <<= transversevelocity2.incomingTransmitted;
   }

   // void respondToScheduledEvent (const Event & /* event */);
   // void respondToChangedInputs();
   // void respondToInputWarning (const InputBase & /* input */);
   // void respondToOutputRequest (const OutputBase & /* output */);
};

#endif // WINDATMOPATH_SYSTEM_CLASS
